#ifndef MEDIAFFEX_H
#define MEDIAFFEX_H

extern "C"
{
#include <libavformat/avformat.h>
}
#include "MediaAVFrame.h"
/*视频输出帧参数*/
typedef struct
{
    std::string width;
    std::string height;
    std::string size;
    std::string pix_fmt;
    std::string filename;
    std::string channels;
    std::string sample_rate;
    std::string bit_rate;
    std::string duration;
    std::string current_fps_rate;
    std::string pkg_fmt_name;
    bool info_state;
} v_sws_spec;

/*音频 参数*/
typedef struct
{
    int sample_rate;
    int ch_Layout;
    int chs;
    int bytes_per_sample_frame;
    AVSampleFormat sample_fmt;
} a_swr_spec;

/*播放装填*/
typedef enum
{
    none,    // 打开播放器时的状态
    ready,   // 加载文件之后
    playing, // 播放中
    pause,   // 暂停
    stop,    // 停止
} v_state;

/*音量*/
typedef enum
{
    min = 0,
    max = 100
} v_volumn;
/*解码方式*/
typedef enum{
    sw,
    hw
}decoder_type;
/*缩放模式*/
typedef enum{
   keep_aspect_ratio,
   stretch_aspect_ratio
}sws_type;

typedef struct{
   int width;
   int height;
   AVPixelFormat pix_fmt;
   sws_type aspect_type;
   decoder_type sw;
}use_opt;

typedef struct{
  
}sys_opt;

#endif