#include "MediaSlider.h"
#include <QMouseEvent>
#include <QStyle>

MediaSlider::MediaSlider(QWidget *parent) : QSlider(parent) {
    setMouseTracking(true);//监听鼠标轨迹
    start=clock();
    x=0;
}

void MediaSlider::mouseReleaseEvent(QMouseEvent *ev) {
    int value = QStyle::sliderValueFromPosition(minimum(),
                maximum(),
                ev->pos().x(),
                width());
    setValue(value);
    QSlider::mouseReleaseEvent(ev);
    emit clicked(this);
}

void MediaSlider::mouseMoveEvent(QMouseEvent *event){
    if(clock()-start >300)
    {
        int temp=event->pos().x();
        if((x - temp < 3 && x - temp > 0) || (temp - x < 3 && temp - x > 0 ))
        {
            int value = QStyle::sliderValueFromPosition(minimum(),
                        maximum(),
                        event->pos().x(),
                        width());
//            _previewMutex.lock();
//            _previewMutex.signal();
            emit preview(value, event->pos().x());
//            _previewMutex.unlock();
        }
        start=clock();
        x=event->pos().x();

    }
    QSlider::mouseMoveEvent(event);
}

void MediaSlider::leaveEvent(QEvent *event){
    emit mouseleave();
}

void MediaSlider::changeValue(int n){
    int valuenow = value();
    setValue(valuenow+n);
    emit clicked(this);
}
