#ifndef SDL2RENDERWIDGET_H
#define SDL2RENDERWIDGET_H
#include <QWidget>
#include <memory>
#include <MediaFFex.h>
#include "SDL2/SDL.h"
#include "Stb_Media.h"
#include <QApplication>
//Refresh Event
#define REFRESH_EVENT  (SDL_USEREVENT + 1)
//Break
#define BREAK_EVENT  (SDL_USEREVENT + 2)

typedef enum
{ 
	media_info_str,
	media_attachment,
	default_logo_str
} font_renderer_type;

typedef enum
{ 
	media_video_image,
	default_logo_image
} media_renderer_type;

class SDL2RenderWidget : public QWidget
{
	Q_OBJECT
public:
	SDL2RenderWidget(QWidget *parent);
	~SDL2RenderWidget();
	void update_image(MediaAVFrame*,v_sws_spec*,use_opt*);	
	void renderer_default_image();
	void renderer_text_info(SDL_Rect m_rect,std::string str,font_renderer_type f_type);
	void set_Size(QSize _size);
	SDL_AudioDeviceID openAudioDevice(SDL_AudioSpec *spec);
private:
	static int refresh_default_image(void *opaque);
private:
	SDL_Window *m_sdl_window = nullptr;
	SDL_Renderer *m_sdl_renderer = nullptr;
	SDL_Texture *m_sdl_texture = nullptr;
	SDL_Surface *m_sdl_surface = nullptr;
	int m_width, m_height;
	Stb_Media *m_stb_media;
	SDL_Event event;
	std::string renderder_str;
	media_renderer_type m_renderer_image_type=default_logo_image;
	int sd_time=1;
	// 默认字符串
	std::string logoImageStr = "F:/SourceCode/VTS/ZFFmpeg/ZFFmpeg/res/img/zvo.png";
	std::string logoStr = "新时代社会主义中国";
signals:
    void signals_change_size(int,int);
};

#endif