#include "Stb_Media.h"

Stb_Media::Stb_Media(){

}
Stb_Media::~Stb_Media(){

}
SDL_Surface* Stb_Media::default_logo_surface(std::string image){
    int req_format = STBI_rgb_alpha;
    int width, height, orig_format;
    unsigned char* data = stbi_load(image.c_str(), &width, &height, &orig_format, req_format);
    if(data==NULL){
        return nullptr;
    }
    int depth, pitch;
    Uint32 pixel_format;
    if (req_format == STBI_rgb) {
        depth = 24;
        pitch = 3*width;
        pixel_format = SDL_PIXELFORMAT_RGB24;
    } else {
        depth = 32;
        pitch = 4*width;
        pixel_format = SDL_PIXELFORMAT_RGBA32;
    }
    return SDL_CreateRGBSurfaceWithFormatFrom((void*)data, width, height,depth, pitch, pixel_format);
}
void Stb_Media::readFileRaw (const std::string & fullPath, std::string & output) {
    std::ifstream fs(fullPath.c_str(), std::ios::in | std::ios::binary);

    if (!fs.is_open()) {
        std::cout << "readFileRaw: " << fullPath << " -- " << "WARNING: Could not open file." << std::endl;
        return;
    }
    else {
        std::cout << "Opened! " << fullPath << std::endl;
    }

    fs.seekg (0, std::ios::end);
    const size_t LEN = fs.tellg();
    fs.seekg (0, std::ios::beg);

    output.resize(LEN);
    fs.read(&output[0], LEN);
    fs.close();
}

void Stb_Media::readFileRaw_toMemory (const std::string & fullPath, sttfont_memory & mem) {
    std::ifstream fs(fullPath.c_str(), std::ios::in | std::ios::binary);

    if (!fs.is_open()) {
        std::cout << "readFileRaw: " << fullPath << " -- " << "WARNING: Could not open file." << std::endl;
        return;
    }
    else {
        std::cout << "Opened! " << fullPath << std::endl;
    }

    fs.seekg (0, std::ios::end);
    const size_t LEN = fs.tellg();
    fs.seekg (0, std::ios::beg);

    mem.alloc(LEN);
    fs.read(mem.data, LEN);
    fs.close();
}
void Stb_Media::setFontArgs(SDL_Renderer* sdl_rander,int f_size,int w_size){
    fc.faceSize = f_size;
    fc.tabWidthInSpaces = w_size;
    sttfont_memory notoSans;
    readFileRaw_toMemory((QDir::currentPath()+"/font/PingFang.ttf").toStdString(), notoSans);
    fc.loadFontManaged(notoSans);
    fc.bindRenderer(sdl_rander);
}
void Stb_Media::setFontSize(int f_size){
    fc.faceSize=f_size;
}
void Stb_Media::setFontWidthInSpaces(int w_size){
    fc.tabWidthInSpaces=w_size;
}