#ifndef ZFFMPEG_H
#define ZFFMPEG_H

#include <QWidget>
#include <QLabel>
#include <QLineEdit>
#include <QDir>
#include <QPushButton>
#include <QVBoxLayout>
#include <QFileDialog>
#include <QtConcurrent/QtConcurrent>
#include <QMessageBox>
#include <QComboBox>
#include <QMouseEvent>

#include "MediaSlider.h"
#include "MediaPlayer.h"
#include "SDL2RenderWidget.h"

class ZFFmpeg : public QWidget
{
    Q_OBJECT
public:
    ZFFmpeg(QWidget *parent = nullptr);
    ~ZFFmpeg();

private:
    /*主Layout*/
    QVBoxLayout* layout_main;
    /*播放器Layout*/
    QVBoxLayout* layout_player;
    QWidget*     widget_player;
    SDL2RenderWidget* widget_sdl2;

    /*进度条和时间Layout*/
    QHBoxLayout* layout_player_state;
    MediaSlider* slider_time;
    QLabel*      label_current_time;
    QLabel*      label_n;
    QLabel*      label_duration_time;  
    /*播放器操作Layout*/
    QHBoxLayout* layout_player_tool;
    /*回退3s*/
    QPushButton* btn_play_reverse3s;
    /*上一个*/
    QPushButton* btn_play_last;
    /*播放or暂停*/
    QPushButton* btn_play;
    /*下一个*/
    QPushButton* btn_play_next;
    /*快进3s*/
    QPushButton* btn_play_speed3s;
    /*停止*/
    QPushButton* btn_stop;
    /*打开文件*/
    QPushButton* btn_open_file;
    QPushButton* btn_open_dir;
    /*变速*/
    QComboBox*   mutipleSpeed;
    /*音量*/
    QPushButton* btn_mutex_volumn;
    MediaSlider* slider_volumn;

    QSpacerItem * sparcer_item = new QSpacerItem(0,0,QSizePolicy::Expanding,QSizePolicy::Fixed);
    
    MediaPlayer *m_player=nullptr;
    QString ms_Path;
protected:
    void keyReleaseEvent(QKeyEvent *event);
    void resizeEvent(QResizeEvent *event);
private:
    QString getTimeText(int value);
public slots:
    void set_open_file();
    void play();
    void pause();
    void stop();
    void slots_change_size(int,int);
    void slots_play_time_changed(MediaPlayer*);
    void slots_on_time_slider_value_changed(MediaPlayer*);
};
#endif // ZFFMPEG_H
